<?php
/*
Plugin Name: Hello Plugin World.
Plugin URI: http://hiromasa.zone.ne.jp/blog/?p=308
Description: Plug-in testing Plug-in :-)
Author: hiromasa
Version: 1.0
Author URI: http://hiromasa.zone.ne.jp/blog/
*/

/*  Copyright 2005 hiromasa  (email : webmaster@hiromasa.zone.ne.jp)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

/******************************************************************************
 * THIS FILE IS CALLED ONLY.
 *****************************************************************************/
if(basename($_SERVER['SCRIPT_FILENAME']) == 'hello-plugin-world.php') {
	die();
}

/******************************************************************************
 * WordPress Plug-in Intarface Define.
 *  - 
 *****************************************************************************/
if(
	class_exists('HelloPluginWorldWP') &&
	class_exists('HelloPluginWorldAdmin')
) {
	
	$helloPluginWorldWP = & new HelloPluginWorldWP();
	
	// 
	// add_filter('the_content', array(&$helloPluginWorldWP, 'outputEntries'));
	// 
	
}

/******************************************************************************
 * Plug-in and Controller Class.
 *  - 
 *  - 
 *  - 
 * 
 * @author		hiromasa
 * @version	1.0
 * 
 *****************************************************************************/
class HelloPluginWorldWP {
	
	var $adminPanel;
	
	/**
	 * The Constructor
	 *  - 
	 * 
	 * @param none
	 * @return Object reference
	 */
	function HelloPluginWorldWP() {
		
		$this->adminPanel = & new HelloPluginWorldAdmin($this);
		add_action('admin_menu', array(&$this, 'addAdminMenu'));
		
	}
	
	/**
	 * Add Administrator User Intafece.
	 * 
	 * @param none
	 * @return none
	 */
	function addAdminMenu() {
		
		add_options_page(
			'Hello Plugin',
			'Hello Plugin',
			8,
			'hello-plugin-world.php',
			array($this->adminPanel, 'viewAdminPanel')
		);
		
	}
	
	/**
	 * 
	 * 
	 * @param none
	 * @return none
	 */
	function sayHello() {
		
		return 'Hello Plug-in World!';
		
	}
	
	/**
	 * 
	 * 
	 * @param none
	 * @return none
	 */
	function outputEntries($content) {
		
		$hello = '<p><strong>Hello Plug-in World!</strong></p>';
		$content = $hello . $content;
		
		return $content;
		
	}
	
}


/******************************************************************************
 * Administrator User Intarface.
 *  - 
 *  - 
 *  - 
 * 
 * @author		hiromasa
 * @version	1.0
 * 
 *****************************************************************************/
class HelloPluginWorldAdmin {
	
	var $plugin;
	
	/**
	 * The Constructor
	 *  - 
	 * 
	 * @param $plugin
	 * @return Object reference
	 */
	function HelloPluginWorldAdmin(&$plugin) {
		
		$this->plugin = $plugin;
		
	}
	
	/**
	 * Administrator Panel.
	 *  - Output admin panel HTML.
	 *  - Get user operation and notisfy controller.
	 * 
	 * @param none
	 * @return none
	 */
	function viewAdminPanel() {
		
		$message = $this->plugin->sayHello();
		
?>
<?php if($message != null) { ?>
	<div class="updated"><p><strong><?php echo $message; ?></strong></p></div>
<?php } ?>
	<div class="wrap"> 
	
	<h2>Hello Plugin World.</h2>
	
	<p>Hello Plugin World.</p>
	
	</div>
<?php
	
	}
	
}
